#!/usr/local/bin/python

import wily
import string
import regex        #,regex_syntax
import os

# environ, envmod is from the book `Programming Python', but os.environ[] is good enough.
# environ, envmod

# Romaji => Kana translation table.
romkantbl={ 'yo':'よ', 'u':'う', 'ko':'こ', 'so':'そ' }
wskktools='▽ 漢字 あ ア a'

#targetwin=envmod.getenv('WILYLABEL')	# Unused currently.
targetwin='WSKK'				# Use fixed name while I am testing this.
#targetwin=os.environ['WILYLABEL']		# Initial use only.  Converted to win id in operation.

c=wily.Connection()				# The Connection is global

# Attaches Initial window, and returns window id .
# c.event() afterwards needs no windowid, so normally return value is unused.
def wskk_init():
	w=c.win(targetwin,0)		# 2nd arg:0 means backup (1) or not.

	oldtools=c.gettools(w)
	c.settools(w, oldtools+wskktools)

	# Attach to the window, grab all messages
	return c.attach(w, wily.GOTO|wily.EXEC|wily.DESTROY|wily.REPLACE)
	#print 'R:', wily.REPLACE		========> 1
	#print 'E:', wily.EXEC			========> 8
	#print 'RE:', wily.REPLACE|wily.EXEC 	========> 9

# Test main loop.  Still something wrong...
def wskk_loop():
	#RE_SYNTAX_EGREP=1
	# regex.set_syntax(regex_syntax.RE_SYNTAX_EGREP)
	
	Kstate=0
	Kstart=0
	while 1:
		# Seems like DESTROY breaks this loop automatically...
		w,ty,f,t,s = e = c.event()
		## Handing raw event over to print like this can't print UTF strint. So,
		## print 'got', c.event()
		print 'got',w,ty,f,t,s
		if ty == wily.EXEC:
			print 'got EXEC event'
			print 'got',w,ty,f,t,s
			c.bounce(e)
			if s == 'Del':
				break
		elif regex.search('[A-Z]', s)>=0:
			Kstate=1
			Kstart=f
			print '1: Kstate',Kstate,'Kstart',Kstart
		elif regex.search(' ', s)>=0:
			Kstate=0
			Kstart=0
			print '2: Kstate',Kstate,'Kstart',Kstart
		else:
			print '3: Kstate',Kstate,'Kstart',Kstart
			if Kstate == 1:
				try:
					tem=romkantbl[string.lower(c.read(w,Kstart,t+1))]
					c.replace(w,Kstart,t+1,tem)
					e = c.event()  # Flush
					print 'Flushed', e
					Kstart=Kstart + len(tem)
				except:
					print 'can\'t romkan conv'
					continue
				#print string.lower(c.read(w,Kstart,t+1))
				#if tem:
				#	c.replace(w,Kstart,t,tem)
	print 'done'

# Dump all event
def wskk_dump_all():
	while 1:
		w,ty,f,t,s = e = c.event()
		print 'Event:',w,ty,f,t,s
		if ty == wily.EXEC and s == 'Del':
			c.bounce(e)
		elif ty == wily.DESTROY:
		 	break


# Test loops
#wskk_init()
#wskk_loop()
#wskk_dump_all()
